#include <ytk/ytk.h>
#include <yw/util.h>

#include <stdlib.h>
#include <stdio.h>

void ypp_init();

YwConnection *conn;
int hello = 0;

int resp(void *useless, const char *name, YwWord *arg)
{
	(void)arg;
	(void)useless;

	if (strcmp(name, "exit") == 0)
		exit(1);
	else if (strcmp(name, "hello") == 0)
		hello = 1;
	else
		return -1;
	
	return 0;
}

int main()
{
	YtkObject *win;
	
	ypp_init();
	conn = ytk_init();

	win = ytk_new_va("YppWindow",  
		"p" "connection", conn,
		"p" "responder", ytk_responder(NULL, resp),
		"i" "width", 40,
		"i" "height", 7,
		"i" "spacing", 1,
		"k" "layout", "horizontal",
		"p" "child", ytk_new_va("YppGroup",
		    "k" "layout", "vertical",
		    "i" "spacing", 1,
		    "p" "child", ytk_new_va("YppGroup",
		        "k" "layout", "vertical",
		        "p" "child", ytk_new_va("YppLabel", 
		            "i" "fg_color", YW_COLOR_ANSI_YELLOW,
			    "i" "bg_color", YW_COLOR_ANSI_BLUE,
			    "d" "text", "Label1 dsjhfksjhd",
		        YW_END),
		        "p" "child", ytk_new_va("YppLabel", 
		            "i" "fg_color", YW_COLOR_ANSI_YELLOW,
			    "i" "bg_color", YW_COLOR_ANSI_BLUE,
			    "d" "text", "Label1 sjhd",
		        YW_END),
		    YW_END),
		    "p" "child", ytk_new_va("YppLabel", 
			"i" "fg_color", YW_COLOR_ANSI_LIGHTCYAN,
			"i" "bg_color", YW_COLOR_ANSI_BLUE,
			"d" "text", "Label2",
		    YW_END),
		    "p" "child", ytk_new_va("YppLabel", 
			"i" "fg_color", YW_COLOR_ANSI_LIGHTCYAN,
			"i" "bg_color", YW_COLOR_ANSI_BLUE,
			"d" "text", "Label3",
		    YW_END),
		YW_END),
		"p" "child", ytk_new_va("YppGroup",
		     "k" "layout", "vertical",
		     "i" "spacing", 1,
		     "p" "child", ytk_new_va("YppInput", 
		         "d" "text", "Hello world!",
		     YW_END),
		     "p" "child", ytk_new_va("YppInput", 
		         "d" "text", "Hello",
		     YW_END),
		     "p" "child", ytk_new_va("YppInput", 
		         "d" "text", "Hello",
		     YW_END),
		     "p" "child", ytk_new_va("YppButton", 
		         "d" "text", "Some button",
			 "k" "event", "exit",
		     YW_END),
		YW_END),
	YW_END);
	
	ytk_draw(win);
	
	for (;;) {
		YwPacket *pkt;
		
		pkt = ytk_process_events(NULL, -1);
		
		if (pkt)
			yw_packet_free(pkt);
	}
	
	return 0;
}
